--CONFIG--------------------------------------------
local x1 = 103		y1 = 23				-- Coordinate for the first blood and the second unholy rune
local x2 = 72		y2 = 61				-- Coordinate for the second blood and the first unholy rune
local x3 = 25		y3 = 80				-- Coordinate for the first and second frost runes
---------------------------------------------------------

SLASH_RUNEHUD1, SLASH_RUNEHUD2 = '/runehud', '/rh';
local function handler(msg, editbox)
local command, rest = msg:match("^(%S*)%s*(.-)$")
	local classLocal, class = UnitClass("player")
	if class == "DEATHKNIGHT" then
		if command == 's' then
			if tonumber(rest) ~= nil then 
				if tonumber(rest) > 0 then
					RHs = tonumber(rest)
					RuneFrame:SetScale(RHs)
					RuneButtonIndividual1:ClearAllPoints()
					RuneButtonIndividual1:SetPoint("CENTER", UIParent, "CENTER", -x1, y1)
				else
					print("RuneHUD: You need to use a valid value for the scale");
				end
			else
				print("RuneHUD: You need to use a valid value for the scale");
			end
		elseif command == 'aoc' then
			if tonumber(rest) ~= nil then 
				if tonumber(rest) >= 0 then
					RHaoc = tonumber(rest)			
					if InCombatLockdown() == false then
						RuneFrame:SetAlpha(RHaoc)
					end
				else
					print("RuneHUD: You need to use a valid value for the alpha");
				end
			else
				print("RuneHUD: You need to use a valid value for the alpha");
			end
		elseif command == 'aic' then
			if tonumber(rest) ~= nil then 
				if tonumber(rest) >= 0 then
					RHaic = tonumber(rest)
					if InCombatLockdown() == true then
						RuneFrame:SetAlpha(RHaic)
					end
				else
					print("RuneHUD: You need to use a valid value for the alpha");
				end
			else
				print("RuneHUD: You need to use a valid value for the alpha");
			end
		elseif command == 'aiv' then
			if tonumber(rest) ~= nil then 
				if tonumber(rest) >= 0 then
					RHaiv = tonumber(rest)
					if UnitInVehicle("player") == true then
						if RHaiv >= 0 then
							RuneFrame:Show()
						end
						RuneFrame:SetAlpha(RHaiv)
					end
				else
					print("RuneHUD: You need to use a valid value for the alpha");
				end
			else
				print("RuneHUD: You need to use a valid value for the alpha");
			end
		elseif command == 'hoc' then
			print("RuneHUD: The cooldown fading options has been removed due to weird bugs with it");
		else
			print("RuneHUD: The available slash commands are:");
			print("RuneHUD: '/rh s <scale>' for scaling");
			print("RuneHUD: '/rh aoc <alpha>' for out of combat alpha");
			print("RuneHUD: '/rh aic <alpha>' for alpha in combat");
			print("RuneHUD: '/rh aiv <alpha>' for alpha when in a vehicle");
		end
	end
end
SlashCmdList["RUNEHUD"] = handler;




local function Runehud_OnEvent(self, event, ...)
local arg1 = ...
	local classLocal, class = UnitClass("player")
	if event == "PLAYER_ENTERING_WORLD" and class == "DEATHKNIGHT" then
		
		--Clearing the old position
		RuneButtonIndividual1:ClearAllPoints()
		RuneButtonIndividual2:ClearAllPoints()
		RuneButtonIndividual3:ClearAllPoints()
		RuneButtonIndividual4:ClearAllPoints()
		RuneButtonIndividual5:ClearAllPoints()
		RuneButtonIndividual6:ClearAllPoints()

		--Setting the new position, change the x,y  values in the end of each line to move the runes
		RuneButtonIndividual1:SetPoint("CENTER", UIParent, "CENTER", -x1, y1)
		RuneButtonIndividual2:SetPoint("CENTER", UIParent, "CENTER", -x2, y2)
		RuneButtonIndividual5:SetPoint("CENTER", UIParent, "CENTER", -x3, y3)
		RuneButtonIndividual6:SetPoint("CENTER", UIParent, "CENTER", x3, y3)
		RuneButtonIndividual3:SetPoint("CENTER", UIParent, "CENTER", x2, y2)
		RuneButtonIndividual4:SetPoint("CENTER", UIParent, "CENTER", x1, y1)

		--Making the runes click through
		RuneButtonIndividual1:EnableMouse(false)
		RuneButtonIndividual2:EnableMouse(false)
		RuneButtonIndividual3:EnableMouse(false)
		RuneButtonIndividual4:EnableMouse(false)
		RuneButtonIndividual5:EnableMouse(false)
		RuneButtonIndividual6:EnableMouse(false)

		RuneButtonIndividual1Cooldown:SetSwipeTexture('interface/CHARACTERFRAME/TempPortraitAlphaMaskSmall')
		RuneButtonIndividual2Cooldown:SetSwipeTexture('interface/CHARACTERFRAME/TempPortraitAlphaMaskSmall')
		RuneButtonIndividual3Cooldown:SetSwipeTexture('interface/CHARACTERFRAME/TempPortraitAlphaMaskSmall')
		RuneButtonIndividual4Cooldown:SetSwipeTexture('interface/CHARACTERFRAME/TempPortraitAlphaMaskSmall')
		RuneButtonIndividual5Cooldown:SetSwipeTexture('interface/CHARACTERFRAME/TempPortraitAlphaMaskSmall')
		RuneButtonIndividual6Cooldown:SetSwipeTexture('interface/CHARACTERFRAME/TempPortraitAlphaMaskSmall')

		
		
		if RHs == nil then
			RHs = 1.2
		end
		if RHaoc == nil then
			RHaoc = 0.1
		end
		if RHaic == nil then
			RHaic = 1
		end
		if RHaiv == nil then
			RHaiv = 0
		end
	end
	
	if (event == "PLAYER_ENTERING_WORLD" or event == "PLAYER_REGEN_ENABLED") and class == "DEATHKNIGHT" and not (UnitInVehicleControlSeat("player") == true and UnitHasVehicleUI("player") == true) then
		RuneFrame:SetAlpha(RHaoc)
		RuneFrame:SetScale(RHs)	
		RuneFrame:SetFrameStrata("LOW")		
	elseif event == "PLAYER_REGEN_DISABLED" and not (UnitInVehicleControlSeat("player") == true and class == "DEATHKNIGHT" and UnitHasVehicleUI("player") == true) then
		RuneFrame:SetAlpha(RHaic)
		RuneFrame:SetScale(RHs)
		RuneFrame:SetFrameStrata("HIGH")
	end
	
	if (event == "UNIT_ENTERED_VEHICLE" and UnitInVehicleControlSeat("player")) == true and  UnitHasVehicleUI("player") == true and class == "DEATHKNIGHT" then
		local unitID = ...
		if unitID == "player" then
			if RHaiv >= 0 then
				RuneFrame:Show()
			end
			RuneFrame:SetAlpha(RHaiv)	
		end
	elseif event == "PLAYER_ENTERING_WORLD" and class == "DEATHKNIGHT" then
		if InCombatLockdown() == true then
			RuneFrame:SetAlpha(RHaic)
			RuneFrame:SetScale(RHs)	
		else 
			RuneFrame:SetAlpha(RHaoc)			
			RuneFrame:SetScale(RHs)
		end
	elseif event == "UNIT_EXITED_VEHICLE" and class == "DEATHKNIGHT" then
		local unitID = ...
		if unitID == "player" then
			if InCombatLockdown() == true then
				RuneFrame:SetAlpha(RHaic)
				RuneFrame:SetScale(RHs)
			else
				RuneFrame:SetAlpha(RHaoc)				
				RuneFrame:SetScale(RHs)
			end
		end
	end
end


local f = CreateFrame("Frame","RuneHUDFrame",UIParent)
f:RegisterEvent("PLAYER_REGEN_DISABLED")
f:RegisterEvent("PLAYER_REGEN_ENABLED")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
f:RegisterEvent("UNIT_EXITED_VEHICLE")
f:RegisterEvent("UNIT_ENTERED_VEHICLE")
f:SetScript("OnEvent", Runehud_OnEvent)
RuneFrame:SetParent(RuneHUDFrame)
